<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentosCCTERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDocumentosCCTERP
 * @subpackage Arrays
 */
class ArrayOfDocumentosCCTERP extends AbstractStructArrayBase
{
    /**
     * The DocumentosCCTERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DocumentosCCTERP[]
     */
    public $DocumentosCCTERP;
    /**
     * Constructor method for ArrayOfDocumentosCCTERP
     * @uses ArrayOfDocumentosCCTERP::setDocumentosCCTERP()
     * @param \StructType\DocumentosCCTERP[] $documentosCCTERP
     */
    public function __construct(array $documentosCCTERP = array())
    {
        $this
            ->setDocumentosCCTERP($documentosCCTERP);
    }
    /**
     * Get DocumentosCCTERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DocumentosCCTERP[]|null
     */
    public function getDocumentosCCTERP()
    {
        return isset($this->DocumentosCCTERP) ? $this->DocumentosCCTERP : null;
    }
    /**
     * Set DocumentosCCTERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosCCTERP[] $documentosCCTERP
     * @return \ArrayType\ArrayOfDocumentosCCTERP
     */
    public function setDocumentosCCTERP(array $documentosCCTERP = array())
    {
        foreach ($documentosCCTERP as $arrayOfDocumentosCCTERPDocumentosCCTERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentosCCTERPDocumentosCCTERPItem instanceof \StructType\DocumentosCCTERP) {
                throw new \InvalidArgumentException(sprintf('The DocumentosCCTERP property can only contain items of \StructType\DocumentosCCTERP, "%s" given', is_object($arrayOfDocumentosCCTERPDocumentosCCTERPItem) ? get_class($arrayOfDocumentosCCTERPDocumentosCCTERPItem) : gettype($arrayOfDocumentosCCTERPDocumentosCCTERPItem)), __LINE__);
            }
        }
        if (is_null($documentosCCTERP) || (is_array($documentosCCTERP) && empty($documentosCCTERP))) {
            unset($this->DocumentosCCTERP);
        } else {
            $this->DocumentosCCTERP = $documentosCCTERP;
        }
        return $this;
    }
    /**
     * Add item to DocumentosCCTERP value
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosCCTERP $item
     * @return \ArrayType\ArrayOfDocumentosCCTERP
     */
    public function addToDocumentosCCTERP(\StructType\DocumentosCCTERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocumentosCCTERP) {
            throw new \InvalidArgumentException(sprintf('The DocumentosCCTERP property can only contain items of \StructType\DocumentosCCTERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DocumentosCCTERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DocumentosCCTERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DocumentosCCTERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DocumentosCCTERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DocumentosCCTERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DocumentosCCTERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentosCCTERP
     */
    public function getAttributeName()
    {
        return 'DocumentosCCTERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDocumentosCCTERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
